---
title: clip-path
slug: Web/SVG/Attribute/clip-path
tags:
  - SVG
  - SVG Attribute
---
<div>{{SVGRef}}</div>

<p>The <strong><code>clip-path</code></strong> presentation attribute defines or associates a clipping path with the element it is related to.</p>

<p class="note"><strong>Note:</strong> As a presentation attribute <code>clip-path</code> can be used as a CSS property.</p>

<p>As a presentation attribute, it can be applied to any element but it has noticeable effects mostly on the following nineteen elements: {{SVGElement('a')}}, {{SVGElement('circle')}}, {{SVGElement('clipPath')}}, {{SVGElement('ellipse')}}, {{SVGElement('g')}}, {{SVGElement('glyph')}}, {{SVGElement('image')}}, {{SVGElement('line')}}, {{SVGElement('marker')}}, {{SVGElement('mask')}}, {{SVGElement('path')}}, {{SVGElement('pattern')}}, {{SVGElement('polygon')}}, {{SVGElement('polyline')}}, {{SVGElement('rect')}}, {{SVGElement('svg')}}, {{SVGElement('symbol')}}, {{SVGElement('text')}}, {{SVGElement('use')}}</p>

<div id="topExample">
<div class="hidden">
<pre class="brush: css">html,body,svg { height:100% }</pre>
</div>

<pre class="brush: html">&lt;svg viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg"&gt;
  &lt;clipPath id="myClip" clipPathUnits="objectBoundingBox"&gt;
    &lt;circle cx=".5" cy=".5" r=".5" /&gt;
  &lt;/clipPath&gt;

  &lt;!-- Top-left: Apply a custom defined clipping path --&gt;
  &lt;rect x="1" y="1" width="8" height="8" stroke="green"
        clip-path="url(#myClip)" /&gt;

  &lt;!-- Top-right: Apply a CSS basic shape on a fill-box
       geometry. This is the same as having a custom clipping
       path with a clipPathUnits set to objectBoundingBox --&gt;
  &lt;rect x="11" y="1" width="8" height="8" stroke="green"
        clip-path="circle() fill-box" /&gt;

  &lt;!-- Bottom-left --&gt;
  &lt;rect x="1" y="11" width="8" height="8" stroke="green"
        clip-path="circle() stroke-box" /&gt;

  &lt;!-- Bottom-right: Apply a CSS basic shape on a view-box
       geometry. This is the same as having a custom clipping
       path with a clipPathUnits set to userSpaceOnUse --&gt;
  &lt;rect x="11" y="11" width="8" height="8" stroke="green"
        clip-path="circle() view-box" /&gt;
&lt;/svg&gt;</pre>

<p>{{EmbedLiveSample('topExample', '100%', 200)}}</p>
</div>

<h2 id="Usage_notes">Usage notes</h2>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Value</th>
   <td>{{cssxref('url')}} | [ {{cssxref('basic-shape')}} || <code>&lt;geometry-box&gt;</code> ] | <code>none</code></td>
  </tr>
  <tr>
   <th scope="row">Default value</th>
   <td><code>none</code></td>
  </tr>
  <tr>
   <th scope="row">Animatable</th>
   <td>Yes</td>
  </tr>
 </tbody>
</table>

<dl>
 <dt>&lt;geometry-box&gt;</dt>
 <dd>An extra information to tell how a {{cssxref('basic-shape')}} is applied to an element: <code>fill-box</code> indicates to use the object bounding box; <code>stroke-box</code> indicates to use the object bounding box extended with the stroke; <code>view-box</code> indicates to use the nearest SVG viewport as the reference box.</dd>
</dl>

<p class="note"><strong>Note:</strong> For more details on the clip-path syntax, see the CSS property {{cssxref('clip-path')}} reference page.</p>

<h2 id="Browser_Compatibility">Browser compatibility</h2>

<p>{{Compat("svg.attributes.presentation.clip-path")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS Masks", "#the-clip-path", 'clip-path')}}</td>
   <td>{{Spec2('CSS Masks')}}</td>
   <td>Extends its application to HTML elements. The <code>clip-path</code> property replaces the deprecated {{cssxref("clip")}} property.</td>
  </tr>
  <tr>
   <td>{{SpecName('SVG1.1', 'masking.html#ClipPathProperty', 'clip-path')}}</td>
   <td>{{Spec2('SVG1.1')}}</td>
   <td>Initial definition (applies to SVG elements only).</td>
  </tr>
 </tbody>
</table>

<h2 id="See_also">See also</h2>

<ul>
 <li>The CSS {{cssxref("clip-path")}} property</li>
</ul>
